/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Colonia;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderColonia;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaColoniaController")
@Scope("prototype")
public class BusquedaColoniaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<Colonia> plwColonia;
	private MyListbox coloniaList;
	private Paging pagingColonia;
	private Textbox txtNombre;
	private Combobox cmbCiudad;

	public MyListbox getColoniaList() {
		return coloniaList;
	}

	public void setColoniaList(MyListbox coloniaList) {
		this.coloniaList = coloniaList;
	}

	public Paging getPagingColonia() {
		return pagingColonia;
	}

	public void setPagingColonia(Paging pagingColonia) {
		this.pagingColonia = pagingColonia;
	}

	public Textbox getTxtNombre() {
		return txtNombre;
	}

	public void setTxtNombre(Textbox txtNombre) {
		this.txtNombre = txtNombre;
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verColonia(new Colonia());
	}

	public Combobox getCmbCiudad() {
		return cmbCiudad;
	}

	public void setCmbCiudad(Combobox cmbCiudad) {
		this.cmbCiudad = cmbCiudad;
	}

	public PagedListWrapper<Colonia> getPlwColonia() {
		return plwColonia;
	}

	public void setPlwColonia(PagedListWrapper<Colonia> plwColonia) {
		this.plwColonia = plwColonia;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {

		super.doAfterCompose(comp);

		coloniaList.setItemRenderer(new RenderColonia());
		coloniaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				Colonia ciu = (Colonia) coloniaList.getSelected();
				verColonia(ciu);
			}
		});

		refreshLista();

		txtNombre.focus();
	}

	private void verColonia(Colonia ci) {
		if (ci == null) {
			return;
		}

		Map args = new HashMap();
		args.put("colonia", ci);
		args.put("coloniaList", coloniaList);

		openWindow("/gui/catalogos/editarColonia.zul",
				Labels.getLabel("editarColoniaController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<Colonia> coloniaBusqueda =
				new HibernateSearchObject<Colonia>(Colonia.class, pagingColonia.getPageSize());

		coloniaBusqueda.addFilterEqual("activo", true);
		coloniaBusqueda.addFilterLike("desccolonia", "%" + txtNombre.getText().trim().concat("%"));
		coloniaBusqueda.addFilterNotEqual("coloniaId", -1);

		Comboitem cbiCiudad = cmbCiudad.getSelectedItem();

		if (cbiCiudad != null) {
			Ciudad ciudad = (Ciudad) cbiCiudad.getValue();
			coloniaBusqueda.addFilterEqual("ciudad", ciudad);
		}

		coloniaBusqueda.addSortAsc("desccolonia");

		plwColonia.init(coloniaBusqueda, coloniaList, pagingColonia);

		if (coloniaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaColoniaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}
}
